# Set phase

scoreboard players set #phase chess.value 2







# Reset scores

scoreboard players set #game_end chess.value 0
scoreboard players set #pawn_promotion chess.value 0
scoreboard players set #en_passant chess.value 0
scoreboard players set #cursor_player chess.id 0







# Reset player scores

scoreboard players reset * chess.laser







# Mark players

execute at @e[type=block_display,tag=white,tag=king] run scoreboard players operation #white_player chess.id = @p chess.id
execute at @e[type=block_display,tag=black,tag=king] run scoreboard players operation #black_player chess.id = @p chess.id







# Assign timer and player turn

scoreboard players set #timer chess.value 110
scoreboard players set #turn chess.value 1







# Terminate pieces

execute as @e[type=block_display,tag=chess_piece] at @s run function chess:animation/terminate







# Spawn new pieces

summon block_display 0 61.5 0 {Tags:["chess_piece","white","rook"  ,"axial"           ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:12}}}]}
summon block_display 1 61.5 0 {Tags:["chess_piece","white","knight"                   ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:13}}}]}
summon block_display 2 61.5 0 {Tags:["chess_piece","white","bishop"        ,"diagonal","medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:14}}}]}
summon block_display 3 61.5 0 {Tags:["chess_piece","white","king"                     ,"tall"  ,"rise","animation"         ],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:16}}}]}
summon block_display 4 61.5 0 {Tags:["chess_piece","white","queen" ,"axial","diagonal","tall"  ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:15}}}]}
summon block_display 5 61.5 0 {Tags:["chess_piece","white","bishop"        ,"diagonal","medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:14}}}]}
summon block_display 6 61.5 0 {Tags:["chess_piece","white","knight"                   ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:13}}}]}
summon block_display 7 61.5 0 {Tags:["chess_piece","white","rook"  ,"axial"           ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:12}}}]}

summon block_display 0 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 1 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 2 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 3 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 4 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 5 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 6 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}
summon block_display 7 61.5 1 {Tags:["chess_piece","white","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:11}}}]}



summon block_display 0 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 1 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 2 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 3 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 4 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 5 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 6 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}
summon block_display 7 61.5 6 {Tags:["chess_piece","black","pawn"                     ,"short" ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:21}},Rotation:[180.0f,0.0f]}]}

summon block_display 0 61.5 7 {Tags:["chess_piece","black","rook"  ,"axial"           ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:22}},Rotation:[180.0f,0.0f]}]}
summon block_display 1 61.5 7 {Tags:["chess_piece","black","knight"                   ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:23}},Rotation:[180.0f,0.0f]}]}
summon block_display 2 61.5 7 {Tags:["chess_piece","black","bishop"        ,"diagonal","medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:24}},Rotation:[180.0f,0.0f]}]}
summon block_display 3 61.5 7 {Tags:["chess_piece","black","king"                     ,"tall"  ,"rise","animation"         ],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:26}},Rotation:[180.0f,0.0f]}]}
summon block_display 4 61.5 7 {Tags:["chess_piece","black","queen" ,"axial","diagonal","tall"  ,"rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:25}},Rotation:[180.0f,0.0f]}]}
summon block_display 5 61.5 7 {Tags:["chess_piece","black","bishop"        ,"diagonal","medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:24}},Rotation:[180.0f,0.0f]}]}
summon block_display 6 61.5 7 {Tags:["chess_piece","black","knight"                   ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:23}},Rotation:[180.0f,0.0f]}]}
summon block_display 7 61.5 7 {Tags:["chess_piece","black","rook"  ,"axial"           ,"medium","rise","animation","silent"],Passengers:[{id:"minecraft:item_display",brightness:{block:0,sky:15},transformation:{right_rotation:[0.0f,0.0f,0.0f,1.0f],scale:[1.0f,1.0f,1.0f],left_rotation:[0.0f,0.0f,0.0f,1.0f],translation:[0.0f,0.5f,0.0f]},item:{id:"minecraft:stone",Count:1b,tag:{CustomModelData:22}},Rotation:[180.0f,0.0f]}]}







# Modify bossbars

bossbar set chess:title name {"text":"Game in Session","color":"gold","bold":true}
bossbar set chess:white name {"text":"Your Turn","color":"gold","bold":true}
bossbar set chess:black name [{"text":"Your ","color":"gold","bold":true},{"text":"Opponent's","color":"dark_red"},{"text":" Turn","color":"gold"}]

bossbar set chess:title players
bossbar set chess:white players
bossbar set chess:black players







# Display title

execute as @a if score @s chess.id = #white_player chess.id run tag @s add white_player
execute as @a if score @s chess.id = #black_player chess.id run tag @s add black_player

title @a title {"text":"Game Start","color":"gold","bold":true}
title @a subtitle [{"selector":"@a[tag=white_player,limit=1]","color":"green"},{"text":" vs ","color":"dark_red"},{"selector":"@a[tag=black_player,limit=1]","color":"green"}]
tellraw @a ["",{"text":"\nGame Start\n","color":"gold","bold":true},{"selector":"@a[tag=white_player,limit=1]","color":"green"},{"text":" vs ","color":"dark_red"},{"selector":"@a[tag=black_player,limit=1]","color":"green"}]

tag @a remove white_player
tag @a remove black_player